
/* Chrysalide - Outil d'analyse de fichiers binaires
 * operand-int.h - prototypes pour la définition générique interne des opérandes
 *
 * Copyright (C) 2008-2012 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_OPERAND_INT_H
#define _ARCH_OPERAND_INT_H


#include "operand.h"



/* Compare un opérande avec un autre. */
typedef bool (* operand_compare_fc) (const GArchOperand *, const GArchOperand *);

/* Traduit un opérande en version humainement lisible. */
typedef void (* operand_print_fc) (const GArchOperand *, GBufferLine *, AsmSyntax);


/* Définition générique d'un opérande d'architecture (instance) */
struct _GArchOperand
{
    GObject parent;                         /* A laisser en premier        */

    char *alt_text;                         /* Eventuel texte alternatif   */
    size_t alt_len;                         /* Taille de ce texte          */
    RenderingTagType alt_tag;               /* Type de rendu               */

};


/* Définition générique d'un opérande d'architecture (classe) */
struct _GArchOperandClass
{
    GObjectClass parent;                    /* A laisser en premier        */

    operand_compare_fc compare;             /* Comparaison d'opérandes     */
    operand_print_fc print;                 /* Texte humain équivalent     */

};



#endif  /* _ARCH_OPERAND_INT_H */
