
/* Chrysalide - Outil d'analyse de fichiers binaires
 * asm.h - prototypes pour les sorties en langage d'assemblage
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_LANG_ASM_H
#define _DECOMP_LANG_ASM_H


#include "../output.h"



#define G_TYPE_ASM_OUTPUT               g_asm_output_get_type()
#define G_ASM_OUTPUT(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_asm_output_get_type(), GAsmOutput))
#define G_IS_ASM_OUTPUT(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_asm_output_get_type()))
#define G_ASM_OUTPUT_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_ASM_OUTPUT, GAsmOutputClass))
#define G_IS_ASM_OUTPUT_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_ASM_OUTPUT))
#define G_ASM_OUTPUT_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_ASM_OUTPUT, GAsmOutputClass))


/* Sortie selon le langage d'assemblage (instance) */
typedef struct _GAsmOutput GAsmOutput;

/* Sortie selon le langage d'assemblage (classe) */
typedef struct _GAsmOutputClass GAsmOutputClass;


/* Indique le type défini pour une sortie en langage d'assemblage. */
GType g_asm_output_get_type(void);

/* Crée une nouvelle sortie en langage d'assemblage.  */
GLangOutput *g_asm_output_new(void);



#endif  /* _DECOMP_LANG_ASM_H */
